/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
package net.hoopajoo.cheeselab3;
import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import net.hoopajoo.swingx.*;

public class CheeseMapNavigator extends JEscDialog implements ActionListener {
    JTextField distance;

    CheeseMapNavigator( Frame owner ) {
        super( owner, false );
        final JDialog dialog = this;
        setTitle( "Navigator" );
        setResizable( false );
        // FIXME: This would really make sense, but it's not included in
        //        java 1.4 so we disable it for now until most of the world
        //        finds out about the wonders of java 1.5.
        // setAlwaysOnTop( true );

        distance = new JTextField( "5", 2 );

        Container cpane = getContentPane();
        cpane.setLayout( new GridBagLayout() );
        GridBagConstraints c = new GridBagConstraints();
        JButton b;

        c.ipadx = 0;
        c.gridx = 3;
        c.gridy = 0;
        cpane.add( b = new JButton( CheeseMap.levelup_action ), c );
        b.setIcon( new ImageIcon( "ui/ui_u.png" ) );
        b.setMargin( new Insets( 0, 0, 0, 0 ) );
        c.gridx = 1;
        c.gridy++;
        cpane.add( b = new JButton(), c );
        b.setIcon( new ImageIcon( "ui/ui_n.png" ) );
        b.setMargin( new Insets( 0, 0, 0, 0 ) );
        b.setToolTipText( "North" );
        b.addActionListener( this );
        b.setActionCommand( "N" );
        c.gridx = GridBagConstraints.RELATIVE;
        c.gridy++;
        cpane.add( b = new JButton(), c );
        b.setIcon( new ImageIcon( "ui/ui_w.png" ) );
        b.setMargin( new Insets( 0, 0, 0, 0 ) );
        b.setToolTipText( "West" );
        b.addActionListener( this );
        b.setActionCommand( "W" );
        cpane.add( distance, c );
        distance.setToolTipText( "The number of rooms by which to move the map" );
        distance.setHorizontalAlignment( JTextField.CENTER );
        cpane.add( b = new JButton(), c );
        b.setIcon( new ImageIcon( "ui/ui_e.png" ) );
        b.setMargin( new Insets( 0, 0, 0, 0 ) );
        b.setToolTipText( "East" );
        b.addActionListener( this );
        b.setActionCommand( "E" );
        c.gridx = 1;
        c.gridy++;
        cpane.add( b = new JButton(), c );
        b.setIcon( new ImageIcon( "ui/ui_s.png" ) );
        b.setMargin( new Insets( 0, 0, 0, 0 ) );
        b.setToolTipText( "South" );
        b.addActionListener( this );
        b.setActionCommand( "S" );
        c.gridx = 3;
        c.gridy++;
        cpane.add( b = new JButton( CheeseMap.leveldown_action ), c );
        b.setIcon( new ImageIcon( "ui/ui_d.png" ) );
        b.setMargin( new Insets( 0, 0, 0, 0 ) );

        pack();

        // Position us to the rightmost upper corner of our parent window.
        setLocation( owner.getX() + owner.getWidth() - getWidth(),
                     owner.getY() );

    }

    public void actionPerformed( ActionEvent e ) {
        CheeseLab.dmesg( 2, "Move" );

        String dir = e.getActionCommand().toLowerCase();

        CheeseLab.dmesg( 3, "  > " + dir );

        int offset = 1;
        try {
            offset = Integer.parseInt( distance.getText() );
        } catch( Exception ee ) {
            ee.printStackTrace();
        }

        int x = 0,
                y = 0,
                    z = 0;

        if( dir.startsWith( "n" ) ) {
            y -= offset;
        } else if( dir.startsWith( "s" ) ) {
            y += offset;
        } else if( dir.startsWith( "e" ) ) {
            x += offset;
        } else if( dir.startsWith( "w" ) ) {
            x -= offset;
        }

        CheeseMap.set_follow_player( false );
        CheeseMap.canvas.move_origin( x, y, z );
    }
}
